Index: channel.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channel.c,v
retrieving revision 1.71
diff -u -r1.71 channel.c
--- channel.c	14 Jan 2004 06:04:46 -0000	1.71
+++ channel.c	21 Jan 2004 19:31:17 -0000
@@ -1744,6 +1744,12 @@
 
 int ast_readstring(struct ast_channel *c, char *s, int len, int timeout, int ftimeout, char *enders)
 {
+        /* we need to return with different values depending on what happened 
+           1 for timeout
+           2 for max digits reached
+           100 + char for ender read - this is usefull if you want to stop getting digits via many enders
+                                       ie # and * and then you can check which one ender was pressed was pressed
+        */
 	int pos=0;
 	int to = ftimeout;
 	char d;
@@ -1767,14 +1773,21 @@
 			return -1;
 		if (d == 0) {
 			s[pos]='\0';
+			/* timeout */
 			return 1;
-		}
+		};
 		if (!strchr(enders, d))
 			s[pos++] = d;
-		if (strchr(enders, d) || (pos >= len)) {
+		if (strchr(enders, d)) {
+			/* digit that finishes gathering */
+                        s[pos]='\0';
+			return (100+d);
+		};
+		if (pos >= len) {
+			/* max length reached */
 			s[pos]='\0';
-			return 0;
-		}
+			return 2;
+		};
 		to = timeout;
 	} while(1);
 	/* Never reached */
